spot 2.2.2

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Modules Pages
Public Member Functions | List of all members
spot::twa_graph_succ_iterator< Graph > Class Template Referencefinal
Inheritance diagram for spot::twa_graph_succ_iterator< Graph >:
Collaboration diagram for spot::twa_graph_succ_iterator< Graph >:

## Public Member Functions
| twa_graph_succ_iterator (const Graph *g, edge t)
void | recycle (edge t)
virtual bool | first () override
| Position the iterator on the first successor (if any). More...
virtual bool | next () override
| Jump to the next successor (if any). More...
virtual bool | done () const override
| Check whether the iteration is finished. More...
virtual const twa_graph_state * | dst () const override
| Get the destination state of the current edge. More...
virtual bdd | cond () const override
| Get the condition on the edge leading to this successor. More...
virtual acc_cond::mark_t | acc () const override
| Get the acceptance mark of the edge leading to this successor. More...
edge | pos () const

## Member Function Documentation

template<class Graph>

virtual acc_cond::mark_t spot::twa_graph_succ_iterator< Graph >::acc | ( |  | ) | const
| inline override virtual

Get the acceptance mark of the edge leading to this successor.

Implements spot::twa_succ_iterator.

template<class Graph>

virtual bdd spot::twa_graph_succ_iterator< Graph >::cond | ( |  | ) | const
| inline override virtual

Get the condition on the edge leading to this successor.

This is a boolean function of atomic propositions.

Implements spot::twa_succ_iterator.

template<class Graph>

virtual bool spot::twa_graph_succ_iterator< Graph >::done | ( |  | ) | const
| inline override virtual

Check whether the iteration is finished.

This function should be called after any call to `first()` or `next()` and before any enquiry about the current state.

The typical use case of done() is in a `for` loop such as:

    for (s->first(); !s->done(); s->next())
      ...

Returns
  false iff the iterator is pointing to a successor.

It is incorrect to call done() if first() hasn't been called before. If done() returns true, it is invalid to call next(), cond(), acc(), or dst().

Implements spot::twa_succ_iterator.

template<class Graph>

virtual const twa_graph_state* spot::twa_graph_succ_iterator< Graph >::dst | ( |  | ) | const
| inline override virtual

Get the destination state of the current edge.

Each call to dst() (even several times on the same edge) creates a new state that has to be destroyed (see state::destroy()). by the caller after it is no longer used.

Note that the same state may occur at different points in the iteration, as different outgoing edges (usually with different labels or acceptance membership) may go to the same state.

Implements spot::twa_succ_iterator.

template<class Graph>

virtual bool spot::twa_graph_succ_iterator< Graph >::first | ( |  | ) |
| inline override virtual

Position the iterator on the first successor (if any).

This method can be called several times in order to make multiple passes over successors.

Warning
  One should always call `done()` (or better: check the return value of first()) to ensure there is a successor, even after `first()`. A common trap is to assume that there is at least one successor: this is wrong.

Returns
  true iff there is at least one successor

If first() returns false, it is invalid to call next(), cond(), acc(), or dst().

Implements spot::twa_succ_iterator.

template<class Graph>

virtual bool spot::twa_graph_succ_iterator< Graph >::next | ( |  | ) |
| inline override virtual

Jump to the next successor (if any).

Warning
  Again, one should always call `done()` (or better: check the return value of next()) ensure there is a successor.

Returns
  true if the iterator moved to a new successor, false if the iterator could not move to a new successor.

If next() returns false, it is invalid to call next() again, or to call cond(), acc() or dst().

Implements spot::twa_succ_iterator.

The documentation for this class was generated from the following file:

- spot/twa/twagraph.hh

Please direct any question, comment, or bug report to the Spot mailing list at spot@lrde.epita.fr.